(*
    String search utility
    Copyright (c) 1994 Alessandro Scotti
*)
{$R-,I-,S-,A+}
uses CString, ShiftAnd;

const
  BUFSIZE = 32*1024;
var
  F: file;
  B: array[ 0..BUFSIZE-1 ] of char;
  L: longint;
  S: string;
  N: word;
  R: longint;
begin
  if( ParamCount <> 2 ) then begin
    WriteLn( 'Searches a string in a file' );
    WriteLn( 'Usage: SAS filename string' );
    Halt;
  end;
  Assign( F, ParamStr(1) );
  S := ParamStr(2);
  Reset( F, 1 );
  saSetPattern( @S[1], Length(S) );
  saSetFuzzy( 2 );
  L := 0;
  while( TRUE ) do begin
    BlockRead( F, B, BUFSIZE, N );
    if( N = 0 ) then begin
      WriteLn( 'Not found!' );
      Close( F );
      Halt;
    end;
    R := saFuzzySearch( B, N );
    if( R >= 0 ) then begin
      WriteLn( 'Found at offset: ', L+R, ' (', LToH(L+R), 'h)' );
      Write( 'Line: ' );
      while( R > 0 )and( B[R] <> #$0A ) do
        Dec( R );
      while( R < BUFSIZE )and( B[R] <> #$0D ) do begin
        Write( B[R] );
        Inc( R );
      end;
      WriteLn;
      Close( F );
      Halt;
    end;
    Inc( L, N );
  end;
end.
